type InetAddress = {
    def getHostName: string
    def toString: string
    def toJava: any
}

newtype InetAddressModule = {
    def create(host: string): InetAddress
    def getLocalHost: InetAddress
    def new(javainet: any): InetAddress
}

let InetAddress: InetAddressModule = {
    def create (host) = new (primitive (1,
					"java.net.InetAddress",
					"getByName",
					"(Ljava/lang/String;)Ljava/net/InetAddress;")
	                               (host))
    def getLocalHost = new (primitive (1,
				       "java.net.InetAddress",
				       "getLocalHost",
				       "()Ljava/net/InetAddress;")
			              ())
    def new(self) = {
        def getHostName = primitive (2,
				     "java.net.InetAddress",
				     "getHostName",
				     "()Ljava/lang/String;")
	                            (self)
        def toString = primitive (2,
				  "java.net.InetAddress",
				  "toString",
				  "()Ljava/lang/String;")
	                         (self)
	val toJava = self
    }
}
