/*  FUNNEL LIBRARY
**  
**  System -- some basic predefined system functions for Funnel
**  
**  27/06/2K, Matthias Zenger
*/

newtype SystemModule = {
    def print(x: any): ()
    def println(x: any): ()
    def readln: string
    def readInt: int
    def readFloat: float
    def error(x: any): null
    def time:long
}

let System: SystemModule = {
    with Console

    // stop execution
    def error (o : any) : null =
      primitive (1, "funnel.runtime.jvm.Predefined", "error", "(Ljava/lang/Object;)V") o

    // return system time in msec
    def time: long =
      primitive (1, "java.lang.System", "currentTimeMillis", "()J") ()
}
