/*  Find all solutions of the "8-queens-puzzle"
**
**  29/03/01, Matthias Zenger
*/

with List

def safe(k: int, pos: List[int]) = {
  val row = pos.head
  def safeUpTo(l: int, rows: List[int]): boolean = {
    (l == 0) || (safeUpTo(l - 1, rows.tail) && {
      val diff = row - rows.head
      (diff != 0) && (diff != l - k) && (diff != k - l)})
  }
  safeUpTo(k - 1, pos.tail)
}

def queens(n: int) = {
  val rows = List.enum(1, n)
  def queenCols(k: int): List[List[int]] = {
    if (k == 0)
      make(Nil[int])
    else
       queenCols(k - 1)
      .map(pos| rows.map(row| row :: pos))
      .foldr(xs, ys: List[List[int]]| xs.append(ys))(Nil)
      .filter(pos| safe(k, pos))
  }
  queenCols(n)
}

queens(8).length
